diff -uNr asterisk-1.2.12.1-orig/apps/app_meetme.c asterisk-1.2.12.1/apps/app_meetme.c
--- asterisk-1.2.12.1-orig/apps/app_meetme.c	2006-09-11 23:47:23.000000000 +0200
+++ asterisk-1.2.12.1/apps/app_meetme.c	2006-10-12 16:54:41.000000000 +0200
@@ -1133,9 +1133,6 @@
 			outfd = -1;
 			ms = -1;
 
-			if (timeout && time(NULL) >= timeout)
-				break;
-
 			/* if we have just exited from the menu, and the user had a channel-driver
 			   volume adjustment, restore it
 			*/
@@ -1145,6 +1142,9 @@
 			menu_was_active = menu_active;
 
 			currentmarked = conf->markedusers;
+			if (currentmarked > 0)  {
+				timeout = 0; /* superfluous after the first marked marked user has entered */
+			}
 			if (!(confflags & CONFFLAG_QUIET) &&
 			    (confflags & CONFFLAG_MARKEDUSER) &&
 			    (confflags & CONFFLAG_WAITMARKED) &&
@@ -1171,6 +1171,8 @@
 			
 			if (confflags & CONFFLAG_WAITMARKED) {
 				if(currentmarked == 0) {
+					if (timeout && time(NULL) >= timeout) /* still waiting for a marked user? */
+						break;
 					if (lastmarked != 0) {
 						if (!(confflags & CONFFLAG_QUIET))
 							if (!ast_streamfile(chan, "conf-leaderhasleft", chan->language))
